package meerkat.voting.controller.callbacks;

/**
 * Created by hai on 18/05/16.
 */
import com.google.common.util.concurrent.FutureCallback;
import meerkat.voting.controller.commands.ControllerCommand;

import java.util.concurrent.LinkedBlockingQueue;

public abstract class ControllerCallback<T> implements FutureCallback<T> {

    private final int requestIdentifier;
    private final long ballotSerialNumber;
    private LinkedBlockingQueue<ControllerCommand> controllerQueue;

    protected ControllerCallback (int requestId,
                                  long ballotSerialNumber,
                                  LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        this.requestIdentifier = requestId;
        this.ballotSerialNumber = ballotSerialNumber;
        this.controllerQueue = controllerQueue;
    }

    protected int getRequestIdentifier () {
        return requestIdentifier;
    }

    protected long getBallotSerialNumber () {
        return ballotSerialNumber;
    }

    protected void enqueueCommand (ControllerCommand command) {
        controllerQueue.add(command);
    }

}
