package meerkat.voting.controller.callbacks;

import meerkat.protobuf.Voting.UIElement;
import meerkat.voting.controller.commands.ControllerCommand;
import meerkat.voting.controller.commands.ReportErrorCommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.LinkedBlockingQueue;

public class WaitForFinishCallback extends ControllerCallback<Void> {
    protected final static Logger logger = LoggerFactory.getLogger(WaitForFinishCallback.class);
    protected final UIElement somethingWrongMessage;

    public WaitForFinishCallback(int requestId,
                                 long ballotSerialNumber,
                                 LinkedBlockingQueue<ControllerCommand> controllerQueue,
                                 UIElement somethingWrongMessage) {
        super(requestId, ballotSerialNumber, controllerQueue);
        this.somethingWrongMessage = somethingWrongMessage;
    }

    @Override
    public void onSuccess(Void v) {
    }

    @Override
    public void onFailure(Throwable t) {
        logger.error("WaitForFinishCallback got a failure: " + t);
        enqueueCommand(new ReportErrorCommand(getRequestIdentifier(),
                getBallotSerialNumber(),
                somethingWrongMessage));
    }
}
